library(data.table)
source(file.path('source', 'JTK_CYCLEv3.1.R'))

runJTK = function(emat, nTimePoints, nReps, period, interval) {
  periods = period %/% interval
  
  jtkdist(nTimePoints, nReps)
  jtk.init(periods, interval)
  rhyJtk = apply(emat, 1, function(z) {
    jtkx(z)
    c(JTK.ADJP, JTK.LAG, JTK.AMP)
  })
  rhyJtk = data.table(t(rhyJtk))
  bhq = p.adjust(unlist(rhyJtk[, 1]), 'BH')
  rhyJtk = cbind(bhq, rhyJtk)
  colnames(rhyJtk) = c('BH.Q', 'ADJ.P', 'LAG', 'AMP')
  rhyJtk[, feature := rownames(emat)]
  rhyJtk[, acrophase := LAG %% period]

  return(rhyJtk)
}
